import numpy as np
import cv2

HAAR_CASCADE_PATH = "haarcascade_frontalface_default.xml"
CAMERA_INDEX = 0

if __name__ == "__main__":
    capture = cv2.VideoCapture(CAMERA_INDEX)
    faces = []

    count = 0
    key = -1

    face_cascade = cv2.CascadeClassifier(HAAR_CASCADE_PATH)
    while (key == -1):
        flag, image = capture.read()
        gray = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)
        # Only run the Detection algorithm every 5 frames to improve performance
        if count % 5 == 0:
            faces = face_cascade.detectMultiScale(gray, 1.3, 5)

        if faces is not None:
            for (x,y,w,h) in faces:
                cv2.rectangle(image,(x,y),(x+w,y+h),(255,0,0),2)

        cv2.imshow('image (press ESC to quit)',image)
        key = cv2.waitKey(10)
        count += 1

    cv2.destroyAllWindows()
